[![build status](https://git.ece.iastate.edu/danc/MicroCART_17-18/badges/master/build.svg)](https://git.ece.iastate.edu/danc/MicroCART_17-18/commits/master)

# MicroCART 
_Microprocessor Controlled Aerial Robotics Team_

**Project Statement**: "To create a modular platform for research in controls and embedded systems."

Since 1998, MicroCART has been building aerial robots. Currently, we are
building a quadcopter that can fly autonomously.

MicroCART has 3 areas of development:
- The **quadcopter** itself
  - The quadcopter has been built from the ground up, incorporating a
    Zybo board that provides the processor and a FPGA, an IMU sensor, motors,
    props, a LiPo battery, a receiver for manual remote control, and a frame 
    that holds it all together.
- The **ground station**
  - The ground station is responsible for issuing important data to the quad
    (like position data from the camera system) and issuing commands to the quad
    for things like configuration and path following directives.
- The **controls model**
  - The quadcopter processor is programmed to implement a PID controller. We use
    a Simulink model to streamline the PID tuning process and to facilitate
    effective characterization of the quad.

## Sections
[Quadcopter](quad/README.md)  
[Ground Station](groundStation/README.md)  
[Controls](controls/README.md)

## Documentation
[How to demo the quadcopter](documentation/how_to_demo.md)  
[How to charge the LiPo batteries](documentation/how_to_charge_lipo.md)  
[Continuous Integration (automatic build process) FAQ](documentation/ci_faq.md)  
[How to document things on Gitlab](documentation/how_to_document_things_on_gitlab.md)  

# Stable Releases
To browse stable releases from previous teams, view the [Tags](/../tags).